using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace MediaSpace
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private GroupLab.Networking.SharedDictionary sharedDictionary1;
		private GroupLab.Networking.Subscription subscription1;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.sharedDictionary1 = new GroupLab.Networking.SharedDictionary(this.components);
			this.subscription1 = new GroupLab.Networking.Subscription(this.components);
			((System.ComponentModel.ISupportInitialize)(this.subscription1)).BeginInit();
			// 
			// sharedDictionary1
			// 
			this.sharedDictionary1.SynchronizingObject = this;
			this.sharedDictionary1.Url = "tcp://localhost:mediaspace";
			// 
			// subscription1
			// 
			this.subscription1.Dictionary = this.sharedDictionary1;
			this.subscription1.Pattern = "/*/info";
			this.subscription1.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription1_Notified);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 470);
			this.IsMdiContainer = true;
			this.Name = "Form1";
			this.Text = "Media Space";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.subscription1)).EndInit();

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		Collabrary.Camera camera;
		Collabrary.VideoCodec codec;
		VideoWindow myVideoWindow;
		Hashtable otherVideoWindows = new Hashtable();

		private void Form1_Load(object sender, System.EventArgs e)
		{
			GroupLab.Networking.Map myUserInfo = new GroupLab.Networking.Map();
			myUserInfo["id"] = this.sharedDictionary1.Id;
			myUserInfo["name"] = "Michael Boyle";
			this.sharedDictionary1["/" + this.sharedDictionary1.Id + "/info"] = myUserInfo;
			this.sharedDictionary1["/" + this.sharedDictionary1.Id + ".transient"] = this.sharedDictionary1.Id;
			this.sharedDictionary1.Open();
			codec = new Collabrary.VideoCodecClass();
			codec.Open("mp42", 320, 240, 1, 0, 0, false);
			camera = new Collabrary.CameraClass();
			camera.Size = Collabrary.CameraSizeStyle.s320x240;
			camera.FrameRate = 1;
			camera.Captured += new Collabrary.CameraEvents_CapturedEventHandler(camera_Captured);
			myVideoWindow = new VideoWindow(this.sharedDictionary1, this.sharedDictionary1.Id);
			myVideoWindow.MdiParent = this;
			myVideoWindow.Show();
		}

		private void camera_Captured(Collabrary.IPhoto Frame)
		{
			this.sharedDictionary1["/" + this.sharedDictionary1.Id + "/video"] = codec.Compress(Frame);
		}

		private void subscription1_Notified(object sender, GroupLab.Networking.SubscriptionEventArgs e)
		{
			if(e.Sender == this.sharedDictionary1.Id)
			{
				return;
			}
			if(e.Reason == GroupLab.Networking.SubscriptionNotification.Add)
			{
				GroupLab.Networking.Map userInfo = e.Value as GroupLab.Networking.Map;
				VideoWindow win = new VideoWindow(this.sharedDictionary1, (Guid) userInfo["id"]);
				win.MdiParent = this;
				win.Show();
				this.otherVideoWindows.Add(userInfo["id"], win);
			}
			else if(e.Reason == GroupLab.Networking.SubscriptionNotification.Remove)
			{
				GroupLab.Networking.Map userInfo = e.PreviousValue as GroupLab.Networking.Map;
				VideoWindow win = this.otherVideoWindows[userInfo["id"]] as VideoWindow;
				win.Close();
				this.otherVideoWindows.Remove(userInfo["id"]);
			}
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			camera.FrameRate = 0;
			this.sharedDictionary1.Close();
		}
	}
}
