using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MediaSpace
{
	/// <summary>
	/// Summary description for VideoWindow.
	/// </summary>
	public class VideoWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private GroupLab.Networking.Subscription subscription1;
		private System.ComponentModel.IContainer components;

		Collabrary.VideoCodec codec;

		public VideoWindow(GroupLab.Networking.SharedDictionary sd, Guid instanceId)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			codec = new Collabrary.VideoCodecClass();
			codec.Open("mp42", 320, 240, 1, 0, 0, false);
			this.subscription1.Pattern = "/" + instanceId + "/video";
			this.subscription1.Dictionary = sd;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.subscription1 = new GroupLab.Networking.Subscription(this.components);
			((System.ComponentModel.ISupportInitialize)(this.subscription1)).BeginInit();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(292, 266);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			// 
			// subscription1
			// 
			this.subscription1.Notified += new GroupLab.Networking.SubscriptionEventHandler(this.subscription1_Notified);
			// 
			// VideoWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.pictureBox1);
			this.Name = "VideoWindow";
			this.Text = "VideoWindow";
			((System.ComponentModel.ISupportInitialize)(this.subscription1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void subscription1_Notified(object sender, GroupLab.Networking.SubscriptionEventArgs e)
		{
			try
			{
				Collabrary.Buffer b = e.Value as Collabrary.Buffer;
				Collabrary.Photo p = codec.Decompress(b) as Collabrary.Photo;
				this.pictureBox1.Image = Image.FromHbitmap(p.Hbitmap);
			}
			catch(Exception)
			{
			}
		}
	}
}
